<script lang="ts">
	export let enabled: boolean;

	export let publicKey: string;

	export let protectSshPortWithFirewall: boolean;

	export let whitelistedIpAddresses: string;
</script>

<label class="form-check form-switch d-block lead mb-2">
	<input class="form-check-input" type="checkbox" bind:checked={enabled} />

	<span class="form-check-label">
		I'd like to have full (<code>root</code>) SSH access to the server.
		<span class:text-danger={enabled}>I understand that with great power comes great potential for damage.</span>
	</span>
</label>

{#if enabled}
	<div class="mb-2">
		<label for="publicKey">
			<i class="fa-solid fa-fw fa-key"></i>
			SSH Public Key
		</label>

		<textarea
			class="form-control"
			id="publicKey"
			bind:value={publicKey}
			placeholder="ssh-ed25519 ..."
			/>

		<p class="text-secondary">
			We can grant access to the provided SSH Public Key.
			We recommend <code>ed25519</code> keys, but <code>rsa</code> keys also work.
			<br />
		</p>
	</div>

	<label class="form-check form-switch d-block lead mb-2">
		<input class="form-check-input" type="checkbox" bind:checked={protectSshPortWithFirewall} />

		<span class="form-check-label">
			Restrict SSH access to whitelisted IP addresses.
			<span class:text-danger={!protectSshPortWithFirewall}>I understand that disabling this exposes my server to external attacks.</span>
		</span>
	</label>

	{#if protectSshPortWithFirewall}
	<div class="mb-2">
		<label for="whitelistedIpAddresses">
			<i class="fa-solid fa-fw fa-map-location"></i>
			Comma-separated IP addresses from which I will access
		</label>

		<input
			class="form-control"
			id="whitelistedIpAddresses"
			bind:value={whitelistedIpAddresses}
			placeholder="1.1.1.1, 8.8.4.4"
			required={enabled}
			/>
	</div>
	{/if}
{/if}
